Welcome to Subscribe On Youtube
Formatted question description: https://leetcode.ca/all/568.html
568. Maximum Vacation Days
Level
Hard
Description
LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.
Rules and restrictions:
 You can only travel among N cities, represented by indexes from 0 to N1. Initially, you are in the city indexed 0 on Monday.
 The cities are connected by flights. The flights are represented as a N * N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
 You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week’s Monday morning. Since flight time is so short, we don’t consider the impact of flight time.
 For each city, you can only have restricted vacation days in different weeks, given an N * K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.
You’re given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.
Example 1:
Input: flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
Output: 12
Explanation:
Ans = 6 + 3 + 3 = 12.
One of the best strategies is:
1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
(Although you start at city 0, we could also fly to and start at other cities since it is Monday.)
2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days.
3rd week : stay at city 2, and play 3 days and work 4 days.
Example 2:
Input: flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
Output: 3
Explanation:
Ans = 1 + 1 + 1 = 3.
Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
For each week, you only have one day to play and six days to work.
So the maximum number of vacation days is 3.
Example 3:
Input: flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
Output: 21
Explanation:
Ans = 7 + 7 + 7 = 21
One of the best strategies is:
1st week : stay at city 0, and play 7 days.
2nd week : fly from city 0 to city 1 on Monday, and play 7 days.
3rd week : fly from city 1 to city 2 on Monday, and play 7 days.
Note:
 N and K are positive integers, which are in the range of [1, 100].
 In the matrix flights, all the values are integers in the range of [0, 1].
 In the matrix days, all the values are integers in the range [0, 7].
 You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won’t be counted as vacation days.
 If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
 We don’t consider the impact of flight hours towards the calculation of vacation days.
Solution
Use dynamic programming. First obtain the number of cities N
and the number of weeks K
from days
. Then create a 2D array dp
with K
rows and N
columns, where dp[i][j]
represents the maximum vacation days for the first i
weeks if the last week is in the j
th city. Initialize all elements in dp
to 1, which represents unreachable state. Then initialize dp[0][0] = days[0][0]
and for all i
from 1 to K  1
, if flights[0][i] == 1
, then dp[0][i] = days[i][0]
.
For i
from 1 to K  1
, for j
from 0 to N  1
, obtain the maximum value in dp[i  1]
such that there is a flight from the previous city to city j
. If there exists a previous city k
such that dp[i  1][k]
is the maximum element in dp[i  1]
such that flights[k][j] == 1
, then update dp[i][j] = dp[i  1][k] + days[j][i]
.
Finally, obtain the maximum element in dp[K  1]
and return.

class Solution { public int maxVacationDays(int[][] flights, int[][] days) { if (flights == null  days == null  flights.length == 0  days.length == 0) return 0; int cities = days.length, weeks = days[0].length; int[][] dp = new int[weeks][cities]; for (int i = 0; i < weeks; i++) { for (int j = 0; j < cities; j++) dp[i][j] = 1; } dp[0][0] = days[0][0]; for (int i = 1; i < cities; i++) { if (flights[0][i] == 1) dp[0][i] = days[i][0]; } for (int i = 1; i < weeks; i++) { for (int j = 0; j < cities; j++) { int maxPrevVacationDays = dp[i  1][j]; for (int k = 0; k < cities; k++) { if ((k == j  flights[k][j] == 1) && dp[i  1][k] >= 0) maxPrevVacationDays = Math.max(maxPrevVacationDays, dp[i  1][k]); } if (maxPrevVacationDays >= 0) dp[i][j] = maxPrevVacationDays + days[j][i]; } } int maxVacationDays = 0; for (int i = 0; i < cities; i++) maxVacationDays = Math.max(maxVacationDays, dp[weeks  1][i]); return maxVacationDays; } }

// OJ: https://leetcode.com/problems/maximumvacationdays/ // Time: O(NK) // Space: O(N) class Solution { public: int maxVacationDays(vector<vector<int>>& F, vector<vector<int>>& D) { int N = F.size(), K = D[0].size(); vector<int> dp(N, INT_MIN), next; dp[0] = 0; for (int i = 0; i < K; ++i) { next.assign(N, INT_MIN); for (int j = 0; j < N; ++j) { for (int k = 0; k < N; ++k) { if (k != j && F[k][j] == 0) continue; next[j] = max(next[j], dp[k]); } next[j] += D[j][i]; } swap(dp, next); } return *max_element(begin(dp), end(dp)); } };

class Solution(object): def maxVacationDays(self, flights, days): """ :type flights: List[List[int]] :type days: List[List[int]] :rtype: int """ ans = 0 dp = [[float("inf")] * len(flights) for _ in range(2)] dp[0][0] = 0 for i in range(len(days[0])): for j in range(len(flights)): for k in range(len(flights)): if flights[k][j] == 1 or j == k: dp[(i + 1) % 2][j] = max(dp[(i + 1) % 2][j], dp[i % 2][k] + days[j][i]) return max(dp[len(days[0]) % 2])

func maxVacationDays(flights [][]int, days [][]int) (ans int) { n, K := len(flights), len(days[0]) f := make([][]int, K+1) for i := range f { f[i] = make([]int, n) for j := range f[i] { f[i][j] = (1 << 30) } } f[0][0] = 0 for k := 1; k <= K; k++ { for j := 0; j < n; j++ { f[k][j] = f[k1][j] for i := 0; i < n; i++ { if flights[i][j] == 1 { f[k][j] = max(f[k][j], f[k1][i]) } } f[k][j] += days[j][k1] } } for j := 0; j < n; j++ { ans = max(ans, f[K][j]) } return } func max(a, b int) int { if a > b { return a } return b }